import 'package:cs_resources/generated/assets.dart';
import 'package:flutter/cupertino.dart';
import 'package:plugin_platform/engine/toast/toast_engine.dart';
import 'package:riverpod_annotation/riverpod_annotation.dart';
import 'package:router/ext/auto_router_extensions.dart';
import 'package:shared/utils/log_utils.dart';

import '../../../router/page/community_page_router.dart';
import '../garagesale_detail/garagesale_detail_page.dart';
import 'for_rent_respository.dart';
import 'for_rent_state.dart';

part 'for_rent_vm.g.dart';

@riverpod
class ForrentVm extends _$ForrentVm {
  late ForrentRepository ForrentRepositoryInstance;
  ForrentState initState() {
    return ForrentState(
        list: [
          {
            'id':1,
            'goods_img':  'https://img2.baidu.com/it/u=3489233687,2364672159&fm=253&fmt=auto&app=120&f=JPEG?w=507&h=500',
            'title': 'Electronic keyboard',
            'price': '\$66',
            'isCollection': true,
            'collection_num': 12,
            'publisher': 'William Jefferson',
            'publish_time': 'June 17,2016 at 7:23 p.m.',
            'publisrher_avator': 'https://img1.baidu.com/it/u=3890726495,1572750319&fm=253&fmt=auto&app=120&f=JPEG?w=500&h=500'
          },
          {
            'id':2,
            'goods_img':  'https://img2.baidu.com/it/u=3489233687,2364672159&fm=253&fmt=auto&app=120&f=JPEG?w=507&h=500',
            'title': 'Electronic keyboard',
            'price': '\$88',
            'isCollection': false,
            'collection_num': 12,
            'publisher': 'William Jefferson',
            'publish_time': 'June 17,2016 at 7:23 p.m.',
            'publisher_avator': 'https://img1.baidu.com/it/u=3890726495,1572750319&fm=253&fmt=auto&app=120&f=JPEG?w=500&h=500'
          },
          {
            'id':3,
            'goods_img':  'https://img2.baidu.com/it/u=3489233687,2364672159&fm=253&fmt=auto&app=120&f=JPEG?w=507&h=500',
            'title': 'Electronic keyboard',
            'price': '\$66',
            'isCollection': true,
            'collection_num': 12,
            'publisher': 'William Jefferson',
            'publish_time': 'June 17,2016 at 7:23 p.m.',
            'publisher_avator': 'https://img1.baidu.com/it/u=3890726495,1572750319&fm=253&fmt=auto&app=120&f=JPEG?w=500&h=500'
          },
        ]
    );
  }

  @override
  ForrentState build(){
    // 引入数据仓库
    ForrentRepositoryInstance = ref.read(forrentRepositoryProvider);
    final state = initState();
    Log.d("--------------------------build---------------------");

    return state;
  }

// 上拉加载
  Future onLoadData() async {
    Log.d("----Forrent_vm-----initListData");
    // await Future.delayed(const Duration(seconds: 2));
    // if(state.list.length >= state.filterCount){
    //   return;
    // }else {
    //   int curPage = state.curPage + 1;
    //   state = state.copyWith(curPage: curPage,);
    //   getListData();
    // }
    // getListData();
  }

  // 获取list 列表数据
  void getListData<T>() async {
    Log.d(" for_rent 加载listData数据---------------start-----");
    try {
      //请求网络
      Map<String, dynamic>  params = {
        "curPage": state.curPage,
        "pageSize": state.pageSize,
      };
      Log.d("请求参数------$params");
      final result = await ForrentRepositoryInstance.fetchForrentList(params);
      Log.d("请求完成结果------${result.data}");
      //校验成功失败
      if (result.isSuccess) {
        // state = state.copyWith(serverTime: result.data);
        state = state;
        ToastEngine.show("获取数据成功");
      } else {
        ToastEngine.show(result.errorMsg ?? "Network Load Error");
      }
    } catch (e) {
      ToastEngine.show("Error: $e");
    }
  }


  // 下拉刷新
  Future refreshListData() async {
    Log.d("----for_rent_vm-----refreshListData ");

    // await Future.delayed(const Duration(seconds: 2));

    state = state.copyWith(curPage: 1, pageSize: 10);
    // ref.invalidateSelf();
    // ref.invalidate(ForrentVmProvider);
    getListData();

  }


  // 点击 like comments  share
  void handlerClickActionBtn(String? actionStr, item){
    final id = item['id'];
    switch (actionStr) {
      case 'like':
        Log.d("点击了 点赞");
        handlerGotoDetail(id);
        break;
      case 'comments':
        Log.d("点击了 评论");
        handlerGotoDetail(id);
        break;
      case 'share':
        Log.d("点击了 分享");
        handlerGotoDetail(id);
        break;
      default:
        break;
    }
  }
  // 去详情页面
  void handlerGotoDetail(id){
    Log.d("去详情页面");
    appRouter.push(GaragesaleDetailPageRoute(id: id, type: 'forrent'));
  }
}