import 'package:cs_resources/generated/assets.dart';
import 'package:flutter/cupertino.dart';
import 'package:plugin_platform/engine/toast/toast_engine.dart';
import 'package:riverpod_annotation/riverpod_annotation.dart';
import 'package:router/ext/auto_router_extensions.dart';
import 'package:shared/utils/log_utils.dart';
import 'package:widgets/load_state_layout.dart';
import 'package:widgets/widget_export.dart';

import '../../../router/page/community_page_router.dart';
// import 'garagesale_detail_respository.dart';
import 'garagesale_detail_state.dart';

part 'garagesale_detail_vm.g.dart';

@riverpod
class GaragesaleDetailVm extends _$GaragesaleDetailVm {
  // late GaragesaleDetailRepository GaragesaleDetailRepositoryInstance;
  bool _needShowPlaceholder = true; //是否展示LoadingView

  // Refresh 控制器
  final EasyRefreshController refreshController = EasyRefreshController(
    controlFinishRefresh: true,  //允许刷新
    controlFinishLoad: true,   //允许加载
  );

  GarageDetailState initState() {
    return GarageDetailState(
        datas: {}
    );
  }

  @override
  GarageDetailState build(){
    // 引入数据仓库
    // GaragesaleDetailRepositoryInstance = ref.read(newsRepositoryProvider);
    final state = initState();
    Log.d("--------------------------build---------------------");

    return state;
  }


  //刷新页面状态
  void changeLoadingState(LoadState loadState, String? errorMsg) {
    state = state.copyWith(
        loadingState: loadState,
        errorMessage: errorMsg
    );
  }

  // 重试请求
  Future retryRequest() async {
    _needShowPlaceholder = true;
    getDetailData();
  }

  // 初始化页面数据
  initPageData() {
    Log.d("----property_news_vm-----initPageData   ${state.loadingState}");
    getDetailData();
  }

  Future getDetailData<T>() async {
    if (_needShowPlaceholder) {
      changeLoadingState(LoadState.State_Loading, null);
    }

    //   try {
    //     //请求网络
    //     Map<String, dynamic>  params = {
    //       "curPage": state.curPage,
    //       "pageSize": state.pageSize,
    //     };
    //     Log.d("请求参数------$params");

    await Future.delayed(const Duration(milliseconds: 1500));

    final Map<String, dynamic> detailData = {
      'id':1,
      'goods_img': 'https://img2.baidu.com/it/u=3489233687,2364672159&fm=253&fmt=auto&app=120&f=JPEG?w=507&h=500',
      'title': 'Electronic keyboard',
      'price': '\$66',
      'description':'Electronic keyboards for sale. I will attend together with the booth.\$10 per day usage Negotiable usage',
      'isCollection': true,
      'collection_num': 12,
      'publisher': 'William Jefferson',
      'publisher_avatar': 'https://img1.baidu.com/it/u=3890726495,1572750319&fm=253&fmt=auto&app=120&f=JPEG?w=500&h=500',
      'publisher_time': 'June 17,2024 at 7:23 PM'
    };

    state = state.copyWith(datas: detailData);

    changeLoadingState(LoadState.State_Success, null);

    refreshController.finishRefresh();

    // 最后赋值
    _needShowPlaceholder = false;
  }


  // 去whatsapp
  gotoWhatsApp(){
    // 跳转 WhatsApp
  }
}