import 'package:plugin_platform/http/http_result.dart';
import 'package:riverpod_annotation/riverpod_annotation.dart';
import 'package:shared/utils/log_utils.dart';
import 'package:plugin_platform/engine/toast/toast_engine.dart';
import '../page/documents_state.dart';
import '../repository/documents_repository.dart';
part 'documents_vm.g.dart';

@riverpod
class DocumentsVm extends _$DocumentsVm {
  late DocumentsRepository documentsRepository;
  DocumentsState initState() {
    return DocumentsState(
      curPage: 1,
      pageSize: 10,
      list: [
        {
          "id": 1,
          "title": "18 Sep 2024 BIK 39#09-XX 1337 psd 1001 sqft",
          "price": "\$1.338 M",
        },
        {
          "id": 2,
          "title": "18 Sep 2024 BIK 39#09-XX 1337 psd 1001 sqft",
          "price": "\$1.338 M",
        },
      ],
      filterCount: 2,
    );
  }

  @override
  DocumentsState build() {
    // 引入数据仓库
    documentsRepository = ref.read(documentsRepositoryProvider);
    // 初始化状态
    DocumentsState state = initState();
    // 初始化列表数据
    return state;
  }

  // 初始化页面数据
  initPageData() {
    Log.d("----property_news_vm-----initPageData");
    refreshListData();
  }

  // 上拉加载
  Future onLoadData() async {
    Log.d("----property_news_vm-----initListData");
    // await Future.delayed(const Duration(seconds: 2));
    // if(state.list.length >= state.filterCount){
    //   return;
    // }else {
    //   int curPage = state.curPage + 1;
    //   state = state.copyWith(curPage: curPage,);
    //   getListData();
    // }
    getListData();
  }
// 去新闻详情页
  void goNewsDetail(String item) {
    Log.d(item);
    // PropertyPage.startInstance(context: context, item: item);
  }
  // 获取list 列表数据
  void getListData<T>() async {
    Log.d("加载listData数据---------------start-----");
    try {
      //请求网络
      Map<String, dynamic>  params = {
        "curPage": state.curPage,
        "pageSize": state.pageSize,
      };
      Log.d("请求参数------$params");
      final result = await documentsRepository.fetchPropertyNewsList(params);
      Log.d("请求完成结果------${result.data}");
      //校验成功失败
      if (result.isSuccess) {
        // state = state.copyWith(serverTime: result.data);
        state = state;
        ToastEngine.show("获取数据成功");
      } else {
        ToastEngine.show(result.errorMsg ?? "Network Load Error");
      }
    } catch (e) {
      ToastEngine.show("Error: $e");
    }
  }


  // 下拉刷新
  Future refreshListData() async {
    Log.d("----property_news_vm-----refreshListData ");

    // await Future.delayed(const Duration(seconds: 2));

    state = state.copyWith(curPage: 1, pageSize: 10);
    // ref.invalidateSelf();
    // ref.invalidate(propertyNewsVmProvider);
    getListData();

  }

}
