import 'package:cs_resources/generated/assets.dart';
import 'package:cs_resources/generated/l10n.dart';
import 'package:cs_resources/theme/app_colors_theme.dart';
import 'package:flutter/material.dart';
import 'package:widgets/ext/ex_widget.dart';
import 'package:widgets/my_load_image.dart';
import 'package:widgets/my_text_view.dart';
import 'package:widgets/widget_export.dart';

class AvatarEditDialog extends StatelessWidget {
  void Function(String path) otherAction;
  void Function() photoAction;

  final List<String> otherImages = [
    "https://pic.rmb.bdstatic.com/bjh/bc3fcc5fadee3ab70dc6f941ae3eb4a21534.jpeg@h_1280",
    "https://img0.baidu.com/it/u=3885044482,1194334042&fm=253&fmt=auto&app=120&f=JPEG?w=800&h=800",
    "https://q0.itc.cn/q_70/images03/20240508/64f00aea4daa4b808e59fdadb939ff41.jpeg",
    "https://ww3.sinaimg.cn/mw690/d315af46ly1h7wfnspdomj20u00u0tef.jpg",
    "https://ww2.sinaimg.cn/mw690/006A8Z5cly1hrhndmtmuaj30he0htq55.jpg",
    "https://ww1.sinaimg.cn/mw690/d315af46ly1h7wfnuxn91j20j60j60uk.jpg",
    "https://img0.baidu.com/it/u=80291486,3068765574&fm=253&fmt=auto&app=138&f=JPEG?w=380&h=380",
    "https://img0.baidu.com/it/u=528233043,1559727912&fm=253&fmt=auto&app=120&f=JPEG?w=500&h=500",
    "https://img0.baidu.com/it/u=691481429,1364097496&fm=253&fmt=auto?w=500&h=500"
  ];

  AvatarEditDialog({
    required this.photoAction,
    required this.otherAction,
  });

  @override
  Widget build(BuildContext context) {
    return Column(
      crossAxisAlignment: CrossAxisAlignment.center,
      mainAxisAlignment: MainAxisAlignment.center,
      children: [
        Container(
          width: double.infinity,
          padding: const EdgeInsets.only(top: 31.5, bottom: 30.5, left: 27.5, right: 27.5),
          decoration: BoxDecoration(
            color: context.appColors.whiteBG,
            borderRadius: const BorderRadius.all(Radius.circular(15)),
          ),
          child: Column(
            mainAxisSize: MainAxisSize.min,
            children: [
              Container(
                width: double.infinity,
                height: 50,
                decoration: const BoxDecoration(
                  color: Color(0XFFE9ECF8),
                  borderRadius: BorderRadius.all(Radius.circular(5)),
                ),
                child: Row(
                  mainAxisSize: MainAxisSize.max,
                  crossAxisAlignment: CrossAxisAlignment.center,
                  mainAxisAlignment: MainAxisAlignment.center,
                  children: [
                    const MyAssetImage(
                      Assets.profileEditDialogUpload,
                      width: 27.5,
                      height: 27.5,
                    ),
                    MyTextView(
                      S.current.upload_a_photo, 
                      fontSize: 16,
                      isFontMedium: true,
                      textColor: context.appColors.textBlack,
                      marginLeft: 12,
                    ),
                  ],
                ).onTap((){
                  onCancel();
                  photoAction.call();
                }),
              ),

              //分割线
              Stack(
                children: [
                  const MyAssetImage(Assets.profileEditXuLine, width: 270, height: 1).marginOnly(top: 10),
                  Align(
                    alignment: Alignment.center,
                    child: MyTextView(
                      S.current.or,
                      textColor: context.appColors.textDarkGray,
                      fontSize: 16,
                      isFontMedium: true,
                    ),
                  ),
                ],
              ).marginOnly(top: 26, bottom: 6),

              //图片九宫格
              GridView.builder(
                shrinkWrap: true,
                physics: const NeverScrollableScrollPhysics(),
                gridDelegate: const SliverGridDelegateWithFixedCrossAxisCount(
                  crossAxisCount: 3, // 每行显示的列数
                  mainAxisSpacing: 20.0, // 主轴（上下）的间距
                  crossAxisSpacing: 15.0, // 交叉轴（左右）的间距
                  childAspectRatio: 1, // 宽高比例
                ),
                itemCount: otherImages.length,
                itemBuilder: (context, index) {
                  return Center(
                    child: MyLoadImage(otherImages[index]).onTap((){
                      onCancel();
                      otherAction.call(otherImages[index]);
                    }),
                  );
                },
              ),
            ],
          ),
        ),
        const MyAssetImage(
          Assets.profileEditDialogDelete,
          width: 25,
          height: 25.5,
        ).onTap(() {
          onCancel();
        }).marginOnly(top: 23.5),
      ],
    ).constrained(width: 325);
  }

//取消弹框
  void onCancel() async {
    SmartDialog.dismiss();
  }
}
