import 'package:auto_route/auto_route.dart';
import 'package:flutter/material.dart';
import 'package:router/ext/auto_router_extensions.dart';
import 'package:router/path/router_path.dart';

import '../modules/global_web_page.dart';
import '../modules/preview_photo_page.dart';

part 'basic_page_router.gr.dart';

/*\
 * 全局的通用页面的路由
 */
@AutoRouterConfig(replaceInRouteName: 'Page|Screen,PageRoute')
class BasicPageRouter extends _$BasicPageRouter {
  @override
  List<AutoRoute> get routes => [
        CustomRoute(page: GlobalWebPageRoute.page, path: RouterPath.globalWeb, transitionsBuilder: applySlideTransition),
        CustomRoute(page: PreviewPhotoPageRoute.page, path: RouterPath.previewImage, transitionsBuilder: applySlideTransition),
      ];
}
